# Copyright 2000 Perl Script Studio and Zhigang Li #

use Fcntl;
use GDBM_File;

$DB_Type = 'GDBM_File';

sub GDBM_WRCREAT{ return O_RDWR|O_CREAT; }

%settings = ( );
%userinfo = ( );
%users = ( );
%cookies = ( );
%fields = ( );
$userid = 0;

tie( %forumdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
%settings = %forumdb;
untie %forumdb;

@provlangs = split( /\s+/, $settings{'provlangs'} );

$lang = $settings{'defaultlang'};
$baseurl = $settings{'baseurl'};

*sExpired = \0;
*sGuest = \1;
*sBanned = \2;
*sMember = \3;
*sSenior = \4;
*sManager = \5;
*sWebmaster = \6;

unless( $skiprefcheck ){
	@validrefs = split( /[,|;]?\s+/, $settings{'validrefs'} );
	my $isvalidref = 0;
	foreach( @validrefs ){
		if( $ENV{'HTTP_REFERER'} =~ m{^http://$_/}i ){
			$isvalidref = 1;
			last;
		}
	}
	unless( $isvalidref ){
		print "Content-type:text/html\nLocation: $settings{'siteroot'}\n\n";
		exit;
	}
}

read (STDIN, $data, $ENV{'CONTENT_LENGTH'});
@postpairs = split(/&/, $data);
@getpairs = split(/&/, $ENV{'QUERY_STRING'});
foreach $data ( @postpairs, @getpairs ){
	my ($name, $value) = split(/=/, $data);
	$value =~ s/%(..)/pack("c", hex($1))/ge;
	$value =~ s/\+/ /g;
	if( defined $fields{$name} ){
		$fields{$name} .= ( "\t" . $value );
	} else {
		$fields{$name} = $value;
	}
}

$fields{'remoteaddr'} = $ENV{'REMOTE_ADDR'};
$fields{'calltime'} = time( );	# Server's system time

foreach ("baseurl", "sitehome", "mailprog", "mydomain", "lang"){
	unless( defined $fields{$_} ){
		$fields{$_} = $settings{$_};
	}
}

my @cks = split( /;\s*/, $ENV{'HTTP_COOKIE'} );
for( @cks ){
	my ($ckname, $ckval) = split( /=/ );
	$cookies{$ckname} = $ckval;
}

sub readusers( ){
	my( %userdb, $id );
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	foreach $id ( keys %userdb ){
		next unless( $id =~ /^\d+$/ );
		my @udata = split( /\t/, $userdb{$id}, 5);
		$users{$id} = $udata[3];	# Display name
	}
	for( 0..5 ){ $settings{ 'g' . $_ } = $userdb{ 'g' . $_ }; }
	untie %userdb;
}

sub getuserinfo( ){
	my $id = shift;
	my( %userdb, @userdata );
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	@userdata = split( /\t/, $userdb{$id} );
	for( 0..$userdb{'fields'}-1 ){
		$userdb{ "f" . $_ } =~ /^(\S+)\t/;
		$userinfo{$1} = ( $userdata[$_] || "" );
	}
	untie %userdb;
}

sub authenticate( ){
	my ( $permission, $lastaccesstime, %sess );
	$permission = $sGuest;
	tie( %sess, $DB_Type, "dat/sess", &GDBM_WRCREAT, 0666 );
	$sid = join( ".", $ENV{'REMOTE_ADDR'}, $cookies{'sessionid'} );
	if( defined $sess{$sid} ){
		( $userid, $lastaccesstime, $permission ) = split( /\t/, $sess{$sid}, 3 );
		if( time - $lastaccesstime > $settings{'expiretime'} * 60 ){
			delete $sess{$ip};
			$permission = $sExpired;
		} else {
			$sess{$sid} = join( "\t", $userid, time, $permission );
		}
	}
	untie %sess;
	return $permission;
}

sub tellerror( ){
	my $err = uc( shift );
	my $hashname = "errmsg" . $lang;
	if( !defined %{$hashname} ){
		tie( %errmsg, $DB_Type, "dat/errmsg", &GDBM_WRCREAT, 0666 );
		my @langs = split( /\t/, $errmsg{'langs'} );
		my %langsubs = ( );
		for( 0..$#langs ){
			$langsubs{$langs[$_]} = $_;
		}
		my $langidx = $langsubs{$lang};
		my $engidx = $langsubs{'eng'};
		foreach $ky ( keys %errmsg ){
			my @msg = split( /\t/, $errmsg{$ky} );
			${$hashname}{$ky} = $msg[$langidx] || $msg[$engidx];
		}
		untie %errmsg;
	}
	print qq{
	<html>
	<head>
	<link rel="stylesheet" href="$baseurl/fe.css">
	<title>$dict{'error'}</title>
	</head>
	<body>
	<h1>$dict{'error'}</h1>
	${$hashname}{$err}
	</body>
	</html>
	};
}

1;
