# Copyright 2000 Perl Script Studio and Zhigang Li #
# ------------------------------------------------ #

# setcookie( $cookiename, $cookievalue, $expiretime )
# delcookie( $cookiename )
# sendemail( $from, $to, $subject, \$msgbody )
# Time format for cookies: Thu, 01-Jan-1970 00:00:00 GMT
# Time format as returned: Thu Jan  1 00:00:00 1970

# Parameters for &setcookie: name, value, and the length of active time in minutes.
# The global %userinfo must be set before calling this function.

use Socket;
$logonform = "";

sub setcookie( ){
	my ( $cookiename, $cookieval, $exptime ) = @_;
	if( $exptime ){
		@cktm = split( /\s+/, gmtime( time + ( $exptime - $userinfo{'timezone'} ) * 3600 ) );
		if( $cktm[2] < 10 ){
			$cktm[2] = "0" . $cktm[2];
		}
		print qq{Set-Cookie: $cookiename=$cookieval; expires=$cktm[0], $cktm[2]-$cktm[1]-$cktm[4] $cktm[3] GMT; domain=$settings{'mydomain'}; path=/\n};
	} else {
		print qq{Set-Cookie: $cookiename=$cookieval; domain=$settings{'mydomain'}; path=/\n};
	}
}

sub delcookie( ){
	my $cookiename = shift;
	print qq{Set-Cookie: $cookiename=; expires=Thu, 01-Jan-1970 00:00:00 GMT; domain=$settings{'mydomain'}; path=/\n};
}

sub sendemail( ){
	my ( $from, $to, $subject, $msgbody ) = @_;
	# Warning: the extra line in $mailbody is essential.
	my $mailbody = 
qq{From: $from
To: $to
Subject: $subject
Content-type: text/plain

$$msgbody
};
	$from =~ /<([^>]+)>/;
	my $fromemail = $1;
	$to =~ /<([^>]+)>/;
	my $toemail = $1;
	if( $settings{'emailmethod'} eq "sendmail" ){
		open( EMAIL, "|$settings{'mailprog'} -oi -t");
		print EMAIL $mailbody;
		close( EMAIL );
	} elsif( $settings{'emailmethod'} eq "blat" ){
		srand($$, time);
		do {
			$tmpfilename = "dat/" . int(rand(100000));
		} while( -e "$tmpfilename" );
		open( REFEMAIL, ">$tmpfilename" );
		print REFEMAIL $mailbody;
		close( REFEMAIL );
		my $cmdline = join( " ", $settings{'blatprog'}, $tmpfilename, "-t", $toemail, "-f", $fromemail );
		system( $cmdline );
		unlink( $tmpfilename );
	} else {
		my($smtpaddr) = ($settings{'smtpserver'} =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/)?
			pack( 'C4',$1,$2,$3,$4 ):
		    	( gethostbyname($settings{'smtpserver'}) )[4];
		socket( MAIL, AF_INET, SOCK_STREAM, ( getprotobyname('tcp') )[2] );
		if( !connect( MAIL, sockaddr_in( ( getservbyname('smtp', 'tcp') )[2], $smtpaddr) ) ){
			my %smtperr = (
			'eng' => "SMTP connection failed. Mail not sent.",
			'fr' => "La connexion de smtp a chou.  Courrier non envoy.",
			'de' => "Smtp-Anschlu fllt aus.  Post nicht gesendet.",
			'gb' => "SMTPʧܣʼδͳ",
			'big5' => "SMTPsѡAl󥼰eXC",
			);
			&sendnews( 0, $thisuser, \($smtperr{$lang}) ) if( $thisuser );
			exit;
		}
		my ($fh) = select(MAIL);
		$| = 1;
		select($fh);
		$_ = <MAIL>;
		print MAIL "HELO $settings{'smtpserver'}\r\n";
		$_ = <MAIL>;
		print MAIL "MAIL FROM: <$fromemail>\r\n";
		$_ = <MAIL>;
		print MAIL "RCPT TO: <$toemail>\r\n";
		$_ = <MAIL>;
		print MAIL "DATA\r\n";
		$_ = <MAIL>;
		print MAIL "To: $to\n";
		print MAIL "From: $from\n";
		print MAIL "Subject: $subject\n\n";
		print MAIL $$msgbody;
		print MAIL "\n.\n";
		$_ = <MAIL>;
		print MAIL "QUIT\r\n";
		$_ = <MAIL>;
		close(MAIL);
	}
}

sub sendnews {
	my ( $from, $to, $newstext ) = @_;
	my %news;
	tie( %news, $DB_Type, "dat/news", &GDBM_WRCREAT, 0666 );
	if( $news{$to} ){
		$news{$to} .= "\t";
	}
	$news{$to} .= join( ":", $from, time, $$newstext );
	untie( %news );
}

sub builderrmsg {
	tie( %errmsgdb, $DB_Type, "dat/errmsg", &GDBM_WRCREAT, 0666 );
	my @langs = split( /\t/, $errmsgdb{'langs'} );
	my %langsubs = ( );
	for( 0..$#langs ){
		$langsubs{$langs[$_]} = $_;
	}
	my $langidx = $langsubs{$lang};
	my $engidx = $langsubs{'eng'};
	foreach $ky ( keys %errmsgdb ){
		my @msg = split( /\t/, $errmsgdb{$ky} );
		$errmsg{$ky} = ( $msg[$langidx] || $msg[$engidx] );
	}
	untie %errmsgdb;
}

sub buildlogonform {
	my $lgtaskid = unpack( "H*", pack( "uS", "logon", 0 ) );
	my $rgtaskid = unpack( "H*", pack( "uS", "register", 0 ) );
	$logonform = qq{
	<script language="JavaScript">
	function validate( frm ){
		if( frm.username.value.length < 4 || frm.username.value.match( /\\W/ ) ){
			alert( "$errmsg{'INVALID_UNAME'}" );
			return false;
		}
		if( frm.password.value.length < 4 || frm.password.value.match( /\\W/ ) ){
			alert( "$errmsg{'INVALID_PWD'}" );
			return false;
		}
		return true;
	}
	</script>
	<form action="admin.cgi" method="post" onSubmit="return validate( this );">
	<input type="Hidden" name="task" value="$lgtaskid">
	<input type="Hidden" name="param" value="$fields{'param'}">
	$dict{'username'} <input type="Text" name="username" accesskey="n" size=20 maxlength=40>
	$dict{'password'} <input type="Password" name="password" accesskey="p" size=20 maxlength=40>
	<input type="Submit" name="logon" value="$dict{'logon'}"> 
	<small><a href="admin.cgi?task=$rgtaskid&amp;param=$fields{'param'}">$dict{'plsregister'}</a></small>
	</form>
	};
}

1;
