#!/usr/bin/perl

require "inc/init.pl";
require "inc/localize.pl";
require "inc/treeop.pl";
require "inc/util.pl";

&readusers( );

@tbllines = ( "tblnoline.gif", "tbldotted.gif", "tbldashed.gif", "tblsolid.gif" );
$ietblline = ( ( $ENV{'HTTP_USER_AGENT'} =~ /MSIE/ && $settings{'defaultline'} < 3 )? qq{style="background-image:url('$baseurl/img/$tbllines[$settings{'defaultline'}]')"}: "" );

$perm = &authenticate( );

$baseurl = $settings{'baseurl'};

( $taskname, $thisuser ) = unpack( "uS", pack( "H*", $fields{'task'} ) );

# A parameter string is expected to extract current browsing info.
( $frlang, $thisuser, $fr, $pg, $md, $msg ) = unpack( "uS*", pack( "h*", $fields{'param'} ) );
$fr ||= 0;
$pg ||= 1;
$msg ||= 0;
if( $md eq "" ){ $md = 2; }
$thisuser ||= "0";	# Guest

if( $frlang && $definedlangs{$frlang} ){
	$lang = $frlang;
}

print "Content-type:text/html; charset=$charsets{$lang}\n\n";

&makedict;

if( $userid != $thisuser ){
	&tellerror( "INVALID_SESS" );
	exit;
}

@permdesc = qw(expired guest banned member senior manager webmaster);
%mystatus = map { $permdesc[$_] => ($_<$sMember)? ($_==$perm): ($_<=$perm) } 0..6;
# Comments about the line above:
# The keys of %mystatus are defined in @permdesc. If permission is 0 ~ 2, then set the
# appropriate key to 1; if 3 ~ 6, then set all lower-priority keys to 1.

$mystatus{'desc'} = $dict{ $permdesc[$perm] };
undef @permdesc;

# If a user id is provided, check it; or otherwise skip and set it to that recorded for this
# session. If a user leaves without logging-out, and back within expiration time, then treat
# it as valid.

if( $thisuser && $thisuser != $userid ){
	$mystatus{'expired'} = 1;
} else {
	$thisuser = $userid;
}

&getuserinfo( $thisuser );
$currtime = &customtime( time );

if( !$userinfo{'timezone'} ){
	$currtime .= " (GMT)";
}

@allsubs = ( );
@allfrsubs = ( );
%recbin = ( );

if( $taskname eq "cleanbin" ){
	tie( %recbin, $DB_Type, "dat/recbin", &GDBM_WRCREAT, 0666 );
	%recbin = ( );
	untie( %recbin );
	my $currlang = $lang;
	my( %deltimeinfo );
	foreach $lang (@provlangs) {
		$deltimeinfo{$lang} = &customtime( time );
	}
	$lang = $currlang;
}

sub findsubnodes {
	my $nid = shift;
	return unless( defined $recbin{$nid} );	# If the sub node does not exist any more, then return.
	push( @allsubs, $nid );		# Top level nodes first!
	my @ndata = split( /\t/, $recbin{$nid}, 12 );
	my @subs = split( /:/, $ndata[2] );
	for( @subs ){
		&findsubnodes( $_ );
	}
}

sub findfrsubnodes {	# Parameter name does not contain the "fr" prefix.
	my $nid = shift;
	my $frname = "fr" . $nid;
	return unless( defined $recbin{$frname} );	# Check existence first!
	push( @allfrsubs, $nid );	# @allfrsubs stores only the numeric ids, not the "fr" prefix.
	my @ndata = split( /\t/, $recbin{$frname}, 12 );
	my @subs = split( /:/, $ndata[2] );
	for( @subs ){
		if( /^fr(\d+)$/ ){
			&findfrsubnodes( $1 );
		} else {	# Must either be a forum node or a message node
			&findsubnodes( $_ );
		}
	}
}

if( $taskname eq "destroy" || $taskname eq "destroyfr" ){
	my $ismsg = ( $taskname eq "destroy" );
	tie( %recbin, $DB_Type, "dat/recbin", &GDBM_WRCREAT, 0666 );
	unless( $taskname eq "destroy" && defined $recbin{$msg} ||
		$taskname eq "destroyfr" && defined $recbin{ "fr" . $fr } ){
		&tellerror( "FILE_NOT_EXIST" );
		exit;
	}
	if( $ismsg ){
		if( $settings{'intellidestroy'} ){
			&findsubnodes( $msg );
		} else {
			push( @allsubs, $msg );
		}
		my @ndata = split( /\t/, $recbin{$msg}, 12 );
		my $par = $ndata[1];
		# If has parent node and parent node is removed, then update its "sons" collection.
		# This is needed only for the first node.
		if( $par && defined $recbin{$par} ){
			@ndata = ( );
			@ndata = split( /\t/, $recbin{$par}, 12 );	# Open the parent record
			my @sdata = split( /:/, $ndata[2] );		# Read the sons collection of the parent node
			my %sdatahash = map{ $_ => 1 } @sdata;		# Map it to a hash
			delete $sdatahash{$msg};			# Remove itself from the collection
			$ndata[2] = join( ":", keys %sdatahash );
			$recbin{$par} = join( "\t", @ndata );		# Put the data back
			my $currlang = $lang;
			my %deltimeinfo;
			foreach $lang (@provlangs) {
				$deltimeinfo{$lang} = &customtime( time );
			}
			$lang = $currlang;
			my %newstext = (
				'eng' => qq{Your message "$ndata[3]" has been permanently removed from recycle bin on $deltimeinfo{'eng'}.},
				'fr' => qq{Votre message "$ndata[3]" a &eacute;t&eacute; de mani&egrave;re permanente retir&eacute; du forum sur $deltimeinfo{'fr'}.},
				'de' => qq{Ihre Meldung "$ndata[3]" ist permanent vom Forum auf $deltimeinfo{'de'} gel&ouml;scht worden.},
				'gb' => qq{ӡ$ndata[3]Ѿ$deltimeinfo{'gb'}ӻվ},
				'big5' => qq{zl$ndata[3]wg_$deltimeinfo{'big5'}q^MC},
			);
			&sendnews( $userid, $ndata[4], \($newstext{ $settings{'defaultlang'} }) );
		}
		for( @allsubs ){
			delete $recbin{$_};
		}
		untie( %recbin );
	} else {	# Must be either forum id or message id.
		if( $settings{'intellidestroy'} ){
			&findfrsubnodes( $fr );
		} else {
			push( @allfrsubs, $fr );
		}
		my @ndata = split( /\t/, $recbin{ "fr" . $fr }, 12 );
		my $par = $ndata[1];
		if( $par && defined $recbin{ "fr" . $par } ){
			@ndata = ( );
			@ndata = split( /\t/, $recbin{ "fr" . $par }, 12 );
			my @sdata = split( /:/, $ndata[2] );
			my %sdatahash = map{ $_ => 1 } @sdata;
			delete $sdatahash{ "fr" . $fr };
			$ndata[2] = join( ":", keys %sdatahash );
			$recbin{ "fr" . $par } = join( "\t", @ndata );
		}
		for( @allsubs ){
			delete $recbin{$_};
		}
		for( @allfrsubs ){
			delete $recbin{ "fr" . $_ };
		}
		untie( %recbin );
		tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
		for( @allfrsubs ){
			delete $frdb{ "fr" . $_ };
		}
		untie( %frdb );
	}
}

if( $taskname eq "restore" || $taskname eq "restorefr" ){
	%unresforumcap = (
		'eng' => qq{Restored messages that were formerly removed but the original forums did not exist any more.},
		'fr' => qq{Les messages restaur&eacute;s qui ont &eacute;t&eacute; autrefois enlev&eacute;s mais les forum initiaux n'ont plus exist&eacute;.},
		'de' => qq{Wiederhgeerstellte Meldungen, die fr&uuml;her gel&ouml;scht wurden, aber die urspr&uuml;nglichen Foren existierenten nicht irgendwie mehr.},
		'gb' => qq{ǰɾָֻӣԭȵѾ޴ӲңԴ},
		'big5' => qq{eQRBZS`lAQײդwgLqdAҥHsboC},
	);
	my $ismsg = ( $taskname eq "restore" );
	my %frdb = ( );
	my ( $np, $pp, $frid ) = ( 0 ) x 3;
	my ( @resnodes, @resfrnodes, @ndata );
	tie( %recbin, $DB_Type, "dat/recbin", &GDBM_WRCREAT, 0666 );
	unless( $taskname eq "restore" && defined $recbin{$msg} ||
		$taskname eq "restorefr" && defined $recbin{ "fr" . $fr } ){
		&tellerror( "FILE_NOT_EXIST" );
		exit;
	}
	if( $ismsg ){
		my $pid = $msg;
		do {
			@ndata = ( );
			unshift( @resnodes, $pid );		# Insert highest nodes to first position.
			@ndata = split( /\t/, $recbin{$pid}, 3 );
			$pid = $ndata[1];
		} while( $pid && $settings{'intellirestore'} && defined $recbin{$pid} );
		$frid = $ndata[0];
		&readtree( "dat/topics.dat" );
		$frptr = &searchtree( $root, $frid );
		if( !$frptr ){
			my %topicdb = ( );
			tie( %forumdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
			$frid = $forumdb{'nexttopicid'};	# The latter will be incremented later.
			$np = &tnode( join( "\t", $frid, $dict{'unresolvedforum'}, $thisuser, time, 0, 1 ) );
			$pp = $root;
			if( !$$pp{'son'} ){
				$$pp{'son'} = $np;
				$$pp{'last'} = $np;
			} else {
				if( $settings{'appendlast'} && ( $pp != $root ) ){
					$$np{'prev'} = $$pp{'last'};
					$$pp{'last'}{'next'} = $np;
					$$pp{'last'} = $np;
				} else {
					$$np{'next'} = $$pp{'son'};
					$$pp{'son'}{'prev'} = $np;
					$$pp{'son'} = $np;
				}
			}
			$$np{'par'} = $pp;
			$pp = $np;
			$$root{'last'} = $np;
			$$np{'par'} = $root;
			$frptr = $np;
			open( FR, ">dat/fr$frid.dat" );
			flock( FR, LOCK_EX );
			print FR join( "\t", "", 0, $dict{'unresolvedforum'}, $thisuser, time, 0, 1 );
			# About the line above: 0 stands for the root record.
			flock( FR, LOCK_UN );
			close( FR );
			$forumdb{'nexttopicid'}++;
			$forumdb{'numtopics'}++;
			$forumdb{'fr' . $frid} = $unresforumcap{$settings{'defaultlang'}};
			untie( %forumdb );
		}
		my @frdata = split( /\t/, $$frptr{'cap'} );
		$frdata[3] += ( $#resnodes + 1 );
		$$frptr{'cap'} = join( "\t", @frdata );
		&writetree( "dat/topics.dat" );
		&readtree( "dat/fr$frid.dat" );
		$pp = ( &searchtree( $root, $pid ) || $root );
		# Comments about the line above: if the $pid node is in the tree, then all the messages will be restored
		# to proper positions as followups to $pid (if non-zero). The restored messages are placed either as the first
		# or the last ones in the follow-up list, depending on the forum settings. If $pid is $root, then the messages
		# will be always put to top.
		tie( %frdb, $DB_Type, "dat/fr$frid", &GDBM_WRCREAT, 0666 );
		foreach $pid ( @resnodes ){
			@ndata = split( /\t/, $recbin{$pid}, 12 );
			delete $recbin{$pid};
			$np = &tnode( join( "\t", $pid, $ndata[3], $ndata[4], $ndata[5], $ndata[6], $ndata[7] ) );
			$frdb{$pid} = join( "\t", $ndata[4], $ndata[8], $ndata[5], $ndata[3], $ndata[11] );
			my $currlang = $lang;
			my( %deltimeinfo, %restimeinfo );
			foreach $lang (@provlangs) {
				$deltimeinfo{$lang} = &customtime( $ndata[10] );
				$restimeinfo{$lang} = &customtime( time );
			}
			$lang = $currlang;
			my %newstext = (
				'eng' => qq{Your message "$ndata[3]" sent to the recycle bin on $deltimeinfo{'eng'} has been restored on $restimeinfo{'eng'}.},
				'fr' => qq{Votre message "$ndata[3]" retir&eacute; sur $deltimeinfo{'fr'} a &eacute;t&eacute; restaur&eacute; sur $restimeinfo{'fr'}.},
				'de' => qq{Ihre Meldung "$ndata[3]" gel&ouml;scht auf $deltimeinfo{'de'} ist auf $restimeinfo{'de'} wiederhgeerstellt worden.},
				'gb' => qq{$deltimeinfo{'gb'}վӡ$ndata[3]Ѿ$restimeinfo{'gb'}ָ},
				'big5' => qq{z_$deltimeinfo{'big5'}Qܦ^l$ndata[3]wg_$restimeinfo{'big5'}`C},
			);
			&sendnews( $userid, $ndata[4], \($newstext{ $settings{'defaultlang'} }) );
			if( !$$pp{'son'} ){
				$$pp{'son'} = $np;
				$$pp{'last'} = $np;
			} else {
				if( $settings{'appendlast'} && ( $pp != $root ) ){
					$$np{'prev'} = $$pp{'last'};
					$$pp{'last'}{'next'} = $np;
					$$pp{'last'} = $np;
				} else {
					$$np{'next'} = $$pp{'son'};
					$$pp{'son'}{'prev'} = $np;
					$$pp{'son'} = $np;
				}
			}
			$$np{'par'} = $pp;
			$pp = $np;
			# Now move the $pp (always the parent node of $np).
		}
		&writetree( "dat/fr$frid.dat" );
		$frdb{'nummsgs'} += ( $#resnodes + 1 );
		untie( %frdb );
		tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
		$frdb{'nummsgs'} += ( $#resnodes + 1 );
		untie( %frdb );
	} else {
		$frid = $fr;
		do {
			@ndata = ( );
			unshift( @resfrnodes, $frid );		# Insert highest nodes to first position.
			@ndata = split( /\t/, $recbin{ "fr" . $frid }, 3 );
			$frid = $ndata[1];
		} while( $frid && defined $recbin{ "fr" . $frid } );
		# Either the parent if $root or it is not removed.
		&readtree( "dat/topics.dat" );
		if( $frid ){
			$pp = ( &searchtree( $root, $frid ) || $root );
			# If the parent it probably not removed, try to locate it; it can't find, use $root.
		} else {
			$pp = $root;
		}
		# Now $pp points to the forum node that will adopt the restored nodes.
		foreach $frid ( @resfrnodes ) {
			@ndata = split( /\t/, $recbin{ "fr" . $frid }, 12 );
			delete $recbin{ "fr" . $frid };
			open( FR, ">dat/fr$frid.dat" );
			print FR join( "\t", "", 0, @ndata[3..5], 0, 1 );
			close( FR );
			tie( %frdb, $DB_Type, "dat/fr$frid", &GDBM_WRCREAT, 0666 );
			$frdb{'nummsgs'} = 0;
			untie( %frdb );
			$np = &tnode( join( "\t", $frid, @ndata[3..5], 0, $ndata[7] ) );
			if( !$$pp{'son'} ){
				$$pp{'son'} = $np;
				$$pp{'last'} = $np;
			} else {
				if( $settings{'appendlast'} && ( $pp != $root ) ){
					$$np{'prev'} = $$pp{'last'};
					$$pp{'last'}{'next'} = $np;
					$$pp{'last'} = $np;
				} else {
					$$np{'next'} = $$pp{'son'};
					$$pp{'son'}{'prev'} = $np;
					$$pp{'son'} = $np;
				}
			}
			$$np{'par'} = $pp;
			$pp = $np;
			# Now point $pp to the immediate parent.
			my $currlang = $lang;
			my( %deltimeinfo, %restimeinfo );
			foreach $lang (@provlangs) {
				$deltimeinfo{$lang} = &customtime( $ndata[10] );
				$restimeinfo{$lang} = &customtime( time );
			}
			$lang = $currlang;
			my %newstext = (
				'eng' => qq{The forum "$ndata[3]" sent to the recycle bin on $deltimeinfo{'eng'} has been restored on $restimeinfo{'eng'}.},
				'fr' => qq{Votre forum "$ndata[3]" retir&eacute; sur $deltimeinfo{'fr'} a &eacute;t&eacute; restaur&eacute; sur $restimeinfo{'fr'}.},
				'de' => qq{Ihr Forum "$ndata[3]" gel&ouml;scht auf $deltimeinfo{'de'} ist auf $restimeinfo{'de'} wiederhgeerstellt worden.},
				'gb' => qq{$deltimeinfo{'gb'}վ顰$ndata[3]Ѿ$restimeinfo{'gb'}ָ},
				'big5' => qq{z_$deltimeinfo{'gb'}Qܦ^Qײա$ndata[3]wg_$restimeinfo{'gb'}`C},
			);
			&sendnews( $userid, $ndata[4], \($newstext{ $settings{'defaultlang'} }) );
			&writetree( "dat/topics.dat" );
		}
		tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
		$frdb{'numtopics'} += ( $#resfrnodes + 1 );
		untie( %frdb );
		# Now all he forum nodes have been restored.
	}
	untie( %recbin );
}

# This is a bar to separate different portions of the layout screen.
$separator = qq{
	<table border=0 cellspacing=0 cellpadding=0 width="100%">
	<tr height="8">
		<td background="$baseurl/img/barbg.gif"><img src="$baseurl/img/clear.gif" border=0 height=8 width=12></td>
	</tr>
	</table>
};

if( $mystatus{'member'} || $mystatus{'banned'} ){
	$fields{'welcomemsg'} = qq{ $dict{'welcome'}, $users{$thisuser}! $dict{'status'}: $mystatus{'desc'} | $dict{'id'}: $userid };
} else {
	$fields{'welcomemsg'} = qq{ $dict{'welcome'}! };
}

$fields{'welcomemsg'} .= qq{ | $dict{'time'}: $currtime | $dict{'topics'}: $settings{'numtopics'} | $dict{'messages'}: $settings{'nummsgs'} | $dict{'hits'}: $settings{'totalhits'} };

# Now read in the template file

$fields{'bbstitle'} = $settings{'bbstitle'};
$fields{'charset'} = $charsets{$lang};

open( TPL, "<tmp/index.htt" );
while( <TPL> ){
	last if( /^<!-- INSERT -->/ );
	s/{%(\w+)%}/$fields{$1}/g;
	print;
}

if( $mystatus{'expired'} || $mystatus{'guest'} ){
	&builderrmsg;
	&buildlogonform;
}

$footer = qq{
	<br>&copy; 2000 Perl Script Studio. All right reserved. By accessing this website, you agree to the Terms and Conditions.
};

tie( %recbin, $DB_Type, "dat/recbin", &GDBM_WRCREAT, 0666 );

@tools_adm = qw(admtag refresh index home search remove setup help exit);

# Toolbar style: 0 - show icon; 1 - show icon and text; 2 -- show text only.

$showtbicon = ( $settings{'toolbarstyle'} <= 1 );
$showtbtext = ( $settings{'toolbarstyle'} >= 1 );

$toolbars{'admtag'} = qq{ <img src="$baseurl/img/tbadmtag.gif" width=5 height=17 border=0> } x $showtbicon;

$toolbars{'refresh'} = join( " ", 
	qq{<a href="javascript:location.reload( );">},
	qq{<img src="$baseurl/img/navrefresh.gif" width=16 height=16 border=0 alt="$dict{'refresh'}">} x $showtbicon,
	( '[' . $dict{'refresh'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'index'} = join( " ",
	qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $userid, 0, 1, $md, 0 ) ) . qq{">},
	qq{<img src="$baseurl/img/navindex.gif" width=16 height=16 border=0 alt="$dict{'index'}">} x $showtbicon,
	( '[' . $dict{'index'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'home'} = join( " ",
	qq{<a href="$settings{'siteroot'}">},
	qq{<img src="$baseurl/img/navhome.gif" width=16 height=16 border=0 alt="$dict{'home'}">} x $showtbicon,
	( '[' . $dict{'home'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'search'} = join( " ",
	qq{<a href="utils.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, 0, $md, 0 ) ) . qq{&amp;task=} . unpack( "H*", pack( "uS", "search", $thisuser ) ) . qq{">},
	qq{<img src="$baseurl/img/navfind.gif" width=16 height=16 border=0 alt="$dict{'search'}">} x $showtbicon,
	( '[' . $dict{'search'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'remove'} = $mystatus{'webmaster'}? join( " ",
	qq{<a href="recbin.cgi?task=} . unpack( "H*", pack( "uS", "cleanbin", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
	qq{<img src="$baseurl/img/navremove.gif" width=16 height=16 border=0 alt="$dict{'cleanbin'}">} x $showtbicon,
	( '[' . $dict{'cleanbin'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'setup'} = $mystatus{'webmaster'}? join( " ",
	qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "setup", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
	qq{<img src="$baseurl/img/navtools.gif" width=16 height=16 border=0 alt="$dict{'setup'}">} x $showtbicon,
	( '[' . $dict{'setup'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'help'} = join( " ",
	qq{<a href="$baseurl/fehelp.html">},
	qq{<img src="$baseurl/img/navhelp.gif" width=16 height=16 border=0 alt="$dict{'help'}">} x $showtbicon,
	( '[' . $dict{'help'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'exit'} = $mystatus{'guest'}? "": join( " ",
	qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "logout", $thisuser ) ) . qq{&param=} . unpack( "h*", pack( "uS*", $lang, $userid, $fr, $pg, $md, $msg ) ) . qq{">},
	qq{<img src="$baseurl/img/navexit.gif" width=16 height=16 border=0 alt="$dict{'logout'}">} x $showtbicon,
	( '[' . $dict{'logout'} . ']' ) x $showtbtext,
	qq{</a>\n} );

print qq{
	<table width=100% border="0">
	<tr>
	<td align="left">
};

foreach $tb ( @tools_adm ){
	print $toolbars{$tb};
}

print qq{
	</td></tr>
	</table>
};

$settings{'othbg'} ||= "white";
$settings{'othfg'} ||= "black";
$settings{'theader'} ||= "darkblue";
$settings{'theaderfg'} ||= "white";

print qq{
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>$dict{'topics'} / $dict{'messages'}</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
		<tr>
		<td bgcolor="$settings{'tblbg'}">
		<table border=0 cellpadding=2 cellspacing=1 width="100%" $ietblline>
		<tr>
			<th align="center" bgcolor="$settings{'theader'}">&nbsp;</th>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'title'}</font></th>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'author'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'modified'}</font></th>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'moderator'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'removed'}</font></th>
		</tr>
};

$currcnt = 0;
$currpg = 1;
$resmsgtask = unpack( "H*", pack( "uS", "restore", $thisuser ) );
$rmmsgtask = unpack( "H*", pack( "uS", "destroy", $thisuser ) );
$resfrtask = unpack( "H*", pack( "uS", "restorefr", $thisuser ) );
$rmfrtask = unpack( "H*", pack( "uS", "destroyfr", $thisuser ) );

# Reverse the sorted keys to display forum nodes first, and latested nodes first
foreach $pid ( reverse sort keys %recbin ) {
	my ( $ismsg, $frid, $msgid, $resparam, $rmparam, $restask, $rmtask ) = ( 0 ) x 7;
	if( $pid =~ /^(\d+)$/ ){
		$ismsg = 1;
		$msgid = $1;
	} elsif( $pid =~ /^fr(\d+)$/ ){
		$ismsg = 0;
		$frid = $1;
	} else {
		next;	# In case of other keys, skip.
	}
	$currcnt++;
	if( $currcnt > $settings{'maxlistentry'} ){
		$currpg++;
		$currcnt = 0;
	}
	next if( $currpg != $pg );
	my @ndata = split( /\t/, $recbin{$pid}, 12 );
	if( $ismsg ){
		$icon = "ms" . ( $ndata[2]? "hd": "no" ) . "sub";
	} else {
		$icon = "fr" . ( $ndata[2]? "hd": "no" ) . "sub";
	}
	$icon .= $ndata[7]? "op": "cl";
	$resparam = unpack( "h*", pack( "uS*", $lang, $userid, $frid, $pg, $md, $msgid ) );
	$rmparam = unpack( "h*", pack( "uS*", $lang, $userid, $frid, $pg, $md, $msgid ) );
	$restask = $ismsg? $resmsgtask: $resfrtask;
	$rmtask = $ismsg? $rmmsgtask: $rmfrtask;
	# Note: only use the last parameter to tell the program itself which node to purge or restore.
	print "<tr>",
		$mystatus{'webmaster'}?
		qq{<td bgcolor="$settings{'othbg'}"><nobr><a href="recbin.cgi?task=$restask&amp;param=$resparam"><img src="$baseurl/img/navrestore.gif" width=16 height=16 border=0></a><a href="recbin.cgi?task=$rmtask&amp;param=$rmparam"><img src="$baseurl/img/navdestroy.gif" width=16 height=16 border=0></nobr></td>}:
		qq{<td bgcolor="$settings{'othbg'}">&nbsp;</td>},
		qq{
		<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}"><img src="$baseurl/img/$icon.gif" width=16 height=16 border=0> $ndata[3]</font></td>
		<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}">$users{$ndata[4]}</font></td>
		<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
	}, &customtime( $ndata[5] ), qq{
		</font></td>
		<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}">$users{$ndata[9]}</font></td>
		<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
	}, &customtime( $ndata[10] ), qq{
		</font></td>
		</tr>
	};
	print qq{
		<tr><td bgcolor="$settings{'othbg'}" colspan=6><font color="$settings{'othfg'}">}, ($ndata[11] =~ /^\s*$/)? "( $dict{'nocontent'} )": $ndata[11], qq{</font></td></tr>
	} if( $ismsg );
}

print qq{
	</table>
	</td></tr></table>
};

untie( %recbin );

# This set of buttons will be used to switch to another language.
$langbuttons = "";
unless( $settings{'hidelangbuttons'} ){
	foreach $langname ( @provlangs ){
		if( $langname ne $lang ){
			my $lbparam = unpack( "h*", pack( "uS*", $langname, $userid, $fr, $pg, $md, $msg ) );
			$langbuttons .= qq{ <a href="recbin.cgi?param=$lbparam"><img src="$baseurl/img/lang} . $langname . qq{.gif" border=0></a> };
		} else {
			$langbuttons .= qq{ <img src="$baseurl/img/lang} . $lang . qq{on.gif"> };
		}
	}
}

if( $currpg > 1 ){
	$pagelinks = qq{<select onchange="location=this.options[this.selectedIndex].value">};
	for( 1..$currpg ){
		if( $_ != $pg ){
			my $pgparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $_, $md, $msg ) );
			$pagelinks .= qq{ <option value="recbin.cgi?param=$pgparam">$_ / $currpg</option> };
		} else {
			$pagelinks .= qq{ <option value="" selected>$dict{'page'} $_</option> };
		}
	}
	$pagelinks .= qq{</select>};
}

@pagebtn = (1, ($pg>1? $pg-1: 1), ($pg<$currpg? $pg+1: $currpg), $currpg );
@pagebtncap = ($dict{'firstpage'}, $dict{'prevpage'}, $dict{'nextpage'}, $dict{'lastpage'});
@pageimg = qw(btngofirst btngoprev btngonext btngolast);
$pagebar = "";
if( $pg == 1 ){
	@shownbtns = ( 2, 3 );
} elsif( $pg >= $currpg ){
	@shownbtns = ( 0, 1 );
} else {
	@shownbtns = ( 0, 1, 2, 3 );
}
if( $currpg > 1 ){
	for( @shownbtns ){
		my $pgparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pagebtn[$_], $md, $msg ) );
		$pagebar .= qq{<a href="recbin.cgi?param=$pgparam"><img src="$baseurl/img/$pageimg[$_].gif" width=16 height=16 border=0 alt="$pagebtncap[$_]"></a>};
	}
}

print qq{
	<form action="admin.cgi" method="post">
	<table width=100% cellpadding=2 cellspacing=0>
	<tr>
	<td align="left">$pagebar$levelbar</td>
	<td align="right">$langbuttons</td>
	</tr>
	</table>
	</form>
	$logonform
};

while( <TPL> ){
	s/{%(\w+)%}/$fields{$1}/g;
	print;
}
close( TPL );
